#讯飞星火说明文档：https://www.xfyun.cn/doc/spark/Web.html#_2-function-call%E8%AF%B4%E6%98%8E

import _thread as thread
import base64
import datetime
import hashlib
import hmac
import json
from urllib.parse import urlparse
import ssl
from datetime import datetime
from time import mktime
from urllib.parse import urlencode
from wsgiref.handlers import format_date_time
from paho.mqtt import client as mqtt_client
import SparkApi

import websocket  # 使用websocket_client

hand=""
action=""
answer = ""

#MQTT设置
broker = 'broker.emqx.io'  
port = 1883   
topic= "FUNCTIONCALL_MQTT"
client_id = 'lucy'

#讯飞星火示例中的函数
def connect_mqtt() :  
    client = mqtt_client.Client(mqtt_client.CallbackAPIVersion.VERSION2) 
    client.connect(broker, port)
    return client

class Ws_Param(object):
    # 初始化
    def __init__(self, APPID, APIKey, APISecret, Spark_url):
        self.APPID = APPID
        self.APIKey = APIKey
        self.APISecret = APISecret
        self.host = urlparse(Spark_url).netloc
        self.path = urlparse(Spark_url).path
        self.Spark_url = Spark_url

    # 生成url
    def create_url(self):
        # 生成RFC1123格式的时间戳
        now = datetime.now()
        date = format_date_time(mktime(now.timetuple()))

        # 拼接字符串
        signature_origin = "host: " + self.host + "\n"
        signature_origin += "date: " + date + "\n"
        signature_origin += "GET " + self.path + " HTTP/1.1"

        # 进行hmac-sha256进行加密
        signature_sha = hmac.new(self.APISecret.encode('utf-8'), signature_origin.encode('utf-8'),
                                 digestmod=hashlib.sha256).digest()

        signature_sha_base64 = base64.b64encode(signature_sha).decode(encoding='utf-8')

        authorization_origin = f'api_key="{self.APIKey}", algorithm="hmac-sha256", headers="host date request-line", signature="{signature_sha_base64}"'

        authorization = base64.b64encode(authorization_origin.encode('utf-8')).decode(encoding='utf-8')

        # 将请求的鉴权参数组合为字典
        v = {
            "authorization": authorization,
            "date": date,
            "host": self.host
        }
        # 拼接鉴权参数，生成url
        url = self.Spark_url + '?' + urlencode(v)
        # 此处打印出建立连接时候的url,参考本demo的时候可取消上方打印的注释，比对相同参数时生成的url与自己代码生成的url是否一致
        return url


# 收到websocket错误的处理
def on_error(ws, error):
    print("### error:", error)


# 收到websocket关闭的处理
def on_close(ws,one,two):
    print(" ")


# 收到websocket连接建立的处理
def on_open(ws):
    thread.start_new_thread(run, (ws,))


def run(ws, *args):
    data = json.dumps(gen_params(appid=ws.appid, domain= ws.domain,question=ws.question))
    ws.send(data)


# 收到websocket消息的处理
def on_message(ws, message):
    global name,hand,action
    #print(message)
    data = json.loads(message)
    #print(message)
    code = data['header']['code']
    if code != 0:
        print(f'请求错误: {code}, {data}')
        ws.close()
    else:
        choices = data["payload"]["choices"]
        status = choices["status"]
        content = choices["text"][0]["content"]
        print(content,end ="")
        global answer
        answer += content
        # print(1)
        if choices["text"][0]["function_call"] is not None: 
            function_call=choices["text"][0]["function_call"]
            name=function_call["name"]
            if name=="LED":
               arguments=json.loads(function_call["arguments"])
               action=arguments["action"]
               hand=arguments["hand"]
            elif name=="MOTOR":
               arguments=json.loads(function_call["arguments"])
               action=arguments["action"]
               hand=arguments["hand"]
            elif name=="SERVO":
               arguments=json.loads(function_call["arguments"])
               action=arguments["action"]
               hand=arguments["hand"]
            RobotControl(name,hand,action)
        if status == 2:
            ws.close()


def gen_params(appid, domain,question):
    """
    通过appid和用户的提问来生成请参数
    """
    data = {
        "header": {
            "app_id": appid,
            "uid": "1234"
        },
        "parameter": {
            "chat": {
                "domain": domain,
                "temperature": 0.5,
                "max_tokens": 2048
            }
        },
        "payload": {
            "message": {
                "text": question
            },
            "functions": {
                "text": [
                    {
                        "name": "LED",
                        "description": "“LED可以控制亮度，你可以使用动作指令让LED亮起不同的亮度",
                        "parameters": {
                            "type": "object",
                            "properties": {
                                "hand": {
                                    "type": "string",
                                    "description": "控制对象，左边的灯或者右边的灯或者两边的灯，比如：left_LED,right_LED,BOTH"
                                },
                                "action": {
                                    "type": "string",
                                    "description": "动作，按照百分比，比如：0%，50%,100%"
                                }
                            },
                            "required": [
                                "hand"
                            ]
                        }
                    },{
                        "name": "MOTOR",
                        "description": "“MOTOR可以控制转速，你可以使用动作指令让MOTOR得到不同的转速",
                        "parameters": {
                            "type": "object",
                            "properties": {
                                "hand": {
                                    "type": "string",
                                    "description": "控制对象，正转和反转的指令，比如：go,back"
                                },
                                "action": {
                                    "type": "string",
                                    "description": "动作，按照百分比，比如：0%,50%,100%"
                                }
                            },
                            "required": [
                                "hand"
                            ]
                        }
                    },{
                        "name": "SERVO",
                        "description": "“SERVO可以控制角度，你可以使用动作指令让SERVO转动到不同角度",
                        "parameters": {
                            "type": "object",
                            "properties": {
                                "hand": {
                                    "type": "string",
                                    "description": "控制对象，舵机，比如：SERVO"
                                },
                                "action": {
                                    "type": "string",
                                    "description": "动作，转动角度，比如：0,90,180"
                                }
                            },
                            "required": [
                                "hand"
                            ]
                        }
                    }
                ]
            }    
        }
    }
    return data

def RobotControl(NAME,HAND,ACTION):
    print(NAME,HAND,action)
    if NAME=="LED":
            print(HAND)
            print(ACTION)
    elif NAME=="MOTOR":
            print(HAND)
            print(ACTION)
    elif NAME=="SERVO":
            print(HAND)
            print(ACTION)
    msg=NAME+"/"+HAND+"/"+ACTION     
    publish(client,msg)
           
def main(appid, api_key, api_secret, Spark_url,domain, question):
    # print("星火:")
    wsParam = Ws_Param(appid, api_key, api_secret, Spark_url)
    websocket.enableTrace(False)
    wsUrl = wsParam.create_url()
    ws = websocket.WebSocketApp(wsUrl, on_message=on_message, on_error=on_error, on_close=on_close, on_open=on_open)
    ws.appid = appid
    ws.question = question
    ws.domain = domain
    ws.run_forever(sslopt={"cert_reqs": ssl.CERT_NONE})
    

#以下密钥信息从控制台获取
appid = "xxxxxx"     #填写控制台中获取的 APPID 信息
api_secret = "yyyyyyyyyyyyy"   #填写控制台中获取的 APISecret 信息
api_key ="zzzzzzzzzzz"    #填写控制台中获取的 APIKey 信息

#用于配置大模型版本，默认“general/generalv2”
domain = "generalv3"    # v3.0版本

#云端环境的服务地址
Spark_url = "ws://spark-api.xf-yun.com/v3.1/chat"  # v3.0环境的地址

def getText(role,content):
    jsoncon = {}
    jsoncon["role"] = role
    jsoncon["content"] = content
    text.append(jsoncon)
    return text

def getlength(text):
    length = 0
    for content in text:
        temp = content["content"]
        leng = len(temp)
        length += leng
    return length

def checklen(text):
    while (getlength(text) > 8000):
        del text[0]
    return text

def publish(client,msg):    
    result = client.publish(topic, msg)  # 发布消息  
    status = result[0]  
    if status == 0:  
        print(f"已发送消息 '{msg}' 到主题 '{topic}'")  
    else:  
        print(f"发送消息到主题 {topic} 失败")
        
text.clear

client = connect_mqtt()
    
while True:
        Input = input("\n" +"我:")
        question = checklen(getText("user",Input))
        SparkApi.answer =""
        print("星火:",end = "")
        main(appid,api_key,api_secret,Spark_url,domain,question)
        getText("assistant",SparkApi.answer)
